.686
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc

includelib kernel32.lib
includelib user32.lib

GenerateTableFile PROTO :DWORD
prand			  PROTO :DWORD
pseed			  PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
AppName 			db "Random tester",0
TableCreateSuccess	db "Table created successfully!",0
NoCreate			db "Unable to create table!",0
MyFileName			db "file.dat",0


.code

start:

	invoke GenerateTableFile,addr MyFileName
	invoke ExitProcess,0




GenerateTableFile PROC FileName:DWORD
    LOCAL hFile:DWORD
    LOCAL BytesWr:DWORD
    LOCAL TableBuf[1024]:BYTE

	invoke pseed,0AAAABBBBh,0CCCCDDDDh,0EEEEFFFFh,11112222h
    lea esi,TableBuf 
    mov ecx,esi
    add ecx,sizeof TableBuf
    @@:
    push ecx
    invoke prand,256
    mov byte ptr [esi],al
    inc esi
    pop ecx
    cmp esi,ecx
    jle @B
    invoke CreateFile,FileName,GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,\
		FILE_ATTRIBUTE_NORMAL, NULL
    .if eax!=INVALID_HANDLE_VALUE
        mov hFile,eax
        invoke WriteFile,hFile,addr TableBuf,sizeof TableBuf,addr BytesWr,NULL
	  invoke CloseHandle,hFile
        invoke MessageBoxA,NULL,addr TableCreateSuccess,addr AppName,MB_OK
    .else
        invoke MessageBoxA,NULL,addr NoCreate,addr AppName,MB_ICONERROR
    .endif  
    ret
GenerateTableFile ENDP

pseed PROC s1:DWORD,s2:DWORD,s3:DWORD,s4:DWORD
	.data
	seed1  dd 0AAAABBBBh
	seed2  dd 0CCCCDDDDh
	seed3  dd 0EEEEFFFFh
	seed4  dd 11112222h
	
	.code
	mov eax,s1 ;if s1 = 0 then use default value
	.if eax!=0
		mov seed1,eax
	.endif
	mov eax,s2 ;if s2 = 0 then use default value
	.if eax!=0
		mov seed2,eax
	.endif
	mov eax,s3 ;if s3 = 0 then use default value
	.if eax!=0
		mov seed3,eax
	.endif
	mov eax,s4 ;if s4 = 0 then use default value
	.if eax!=0
		mov seed4,eax
	.endif
	ret

pseed ENDP

prand PROC base:DWORD
	;seed1 = AAAABBBB
	;seed2 = CCCCDDDD
	;seed3 = EEEEFFFF
	;seed4 = 11112222
	
	mov eax,seed1 ;AAAABBBB
	mov ebx,seed2 ;CCCCDDDD
	mov ecx,seed3 ;EEEEFFFF
	mov edx,seed4 ;11112222
;start shifting	
	xchg ax,bx    ;eax = AAAADDDD, ebx = CCCCBBBB
	xchg cx,dx	  ;ecx = EEEE2222, edx = 1111FFFF	
	xchg al,cl	  ;eax = AAAADD22, ecx = EEEE22DD
	xchg bl,dl	  ;ebx = CCCCBBFF, edx = 1111FFBB
	push eax	  ;AAAADD22
	push ecx      ;EEEE22DD
	shl eax,8	  ;AADD2200
	shr ecx,24	  ;000000EE
	add eax,ecx   ;AADD22EE
	mov seed1,eax	  ;s1 = AADD22EE
	pop ecx		  ;EEEE22DD
	pop eax 	  ;AAAADD22
	push ecx	  ;EEEE22DD
	shr eax,24	  ;000000AA
	push edx	  ;1111FFBB
	shl edx,8	  ;11FFBB00
	add edx,eax	  ;11FFBBAA
	mov seed2,edx    ;s2 = 11FFBBAA
	pop edx		  ;1111FFBB
	shr edx,24	  ;00000011
	push ebx	  ;CCCCBBFF
	shl ebx,8	  ;CCBBFF11
	mov seed3,ebx	  ;s3 = CCBBFF11
	pop ebx		  ;CCCCBBFF
	shr ebx,24	  ;000000CC
	pop ecx		  ;EEEE22DD
	shl ecx,8	  ;EE22DD00
	add ecx,ebx   ;EE22DDCC
	mov seed4,ecx    ;s4 = EE22DDCC
;start calculating
	mov eax,seed1
	mov ecx,16587
	xor edx,edx
	div ecx		  ;AADD22EE / 16587, result in eax, remainder in edx
	mov ebx,seed2    ;11FFBBAA
	xchg ebx,eax  
	sub eax,ebx   ;11FFBBAA - remainder
	mov ecx,edx
	xor edx,edx
	mul ecx
	mov seed2,eax    ;seed2 = (s1 / 16587)*(s2 - (s1 % 16587))
	
	mov ecx,29753
	xor edx,edx
	div ecx		 ; (s2 / 29753)
	mov ebx,seed3   ;CCBBFF11
	xchg ebx,eax
	sub eax,ebx  ;CCBBFF11 - remainder
	mov ecx,edx	
	xor edx,edx
	mul ecx		
	mov seed3,eax   ;seed3 = (s2 / 29753)*(s3 - (s2 % 29753))
	
	mov ecx,39744
	xor edx,edx
	div ecx		 ; (s3 / 39744)
	mov ebx,seed4   ;EE22DDCC
	xchg ebx,eax
	sub eax,ebx  ;EE22DDCC - remainder
	mov ecx,edx	
	xor edx,edx
	mul ecx		
	mov seed4,eax   ;seed4 = (s3 / 39744)*(s4 - (s3 % 39744))	
	
	mov ecx,59721
	xor edx,edx
	div ecx		 ; (s4 / 59721)
	mov ebx,seed1   ;AADD22EE
	xchg ebx,eax
	sub eax,ebx  ;AADD22EE - remainder
	mov ecx,edx	
	xor edx,edx
	mul ecx		
	mov seed1,eax   ;seed1 = (s4 / 59721)*(s1 - (s4 % 59721))	
;use every last byte of each new seed
	shl eax,24
	mov ebx,seed2
	shl ebx,24
	shr ebx,8
	add eax,ebx
	mov ebx,seed3
	shl ebx,24
	shr ebx,16
	add eax,ebx
	mov ebx,seed4
	add al,bl	
	mov ebx,seed1
	xor eax,ebx
	xor edx,edx
	div base	
    mov eax,edx
    ret

prand ENDP

end start